package pltag.german;

import pltag.german.MorphInfo.Case;



public class MorphAnnotator {
	
	public MorphAnnotator() {
		
	}

// OLD
//	public void setMorphology(ElementaryTree elementaryTree) {
//		setMorphology(elementaryTree.getRoot(), elementaryTree);
//	}
//
//	private void setMorphology(ElementaryTreeNode node, ElementaryTree elementaryTree) {
//		
//		// recursion
//		for (int i = 0; i < node.getChildren().size(); i++) {
//			ElementaryTreeNode child = node.getChildren().get(i);
//			setMorphology(child, elementaryTree);
//		}
//		
//		setCase(node, elementaryTree);
//	}
//
//	private void setCase(ElementaryTreeNode node, ElementaryTree elementaryTree) {
//		// case annotation for DPs
////		if (node.getPhrasalCategory().matches("DP")) {
////			TreeNode head = node.getTreeNodeBottom().getHeadChild();
////			while (!head.isLeaf()) {
////				head = head.getHeadChild();
////			}
////			MorphInfo.Case c = ((LeafNode)head).getMorphology().getCase();
////			node.getMorphology().setCase(c);
////		}
//		
//		// case annotation for NPs
//		if (node.getPhrasalCategory().matches("NP|DP")) {
//			// Old version only worked for Sis-Adj
//			//if (node.getTreeNodeBottom().isCoordinatedCat() &&
//			//		elementaryTree.getType() == NodeStatus.ADJ) {
//			
//			// annotation of nodes within a coordination auxiliary tree
//			if (elementaryTree.getType() == NodeStatus.ADJ
//					&& elementaryTree.getRoot().getTreeNodeBottom().isCoordinatedCat()
//					&& elementaryTree.getFoot() != node 
//					&& !node.isSubst()) {
//				// foot already has case because of bottom-up traversal
//				ElementaryTreeNode foot = elementaryTree.getFoot();
//				MorphInfo.Case c = foot.getMorphology().getCase();
//				node.getMorphology().setCase(c);
//			}
//			else {
//				
//				TreeNode head = node.getTreeNodeBottom();
//				
//				while (!head.isLeaf()) {
//					
//					// skip coordination auxiliary trees
//					if (head.getBottom().isAdjTree()
//							&& head.getBottom().getRoot().isCoordinatedCat()
//							&& head.getBottom().containsNode(head)) {
//							//&& head.getBottom().getRoot() == head) {
//						head = head.getBottom().getFoot();
//						if (head.isLeaf()) break;
//					}
//					head = head.getHeadChild();
//				}
//				MorphInfo.Case c = ((LeafNode)head).getMorphology().getCase();
//				
////				if (c == MorphInfo.Case.NONE) {
//////					//System.out.println("!!!! No Case");
////					if (node.isSubst()) {
////						// try to infer the case top-down (not possible for PPs)
////						if (node.getFunctionalCategory().matches("SB|PD|EP")) {
////							c = MorphInfo.Case.NOM;
////						}
////						else if (node.getFunctionalCategory().matches("OA|OA2")) {
////							c = MorphInfo.Case.ACC;
////						}
////						else if (node.getFunctionalCategory().matches("OG")) {
////							c = MorphInfo.Case.GEN;
////						}
////						else if (node.getFunctionalCategory().matches("DA")) {
////							c = MorphInfo.Case.DAT;
////						}
////					}
////				}
////				
////				if (c == MorphInfo.Case.NONE) {
////					System.out.println("!!!! No Case");
////				}
//				
//				node.getMorphology().setCase(c);
//			}
//		}
//		
//	}


	public void setMorphology(TigerTree tree) {
		setCase(tree);
		// Maybe more here later
	}


	private void setCase(TigerTree tree) {
		setCaseBottomUp(tree.getRoot());
		setCaseTopDown(tree.getRoot());
		
	}


	private void setCaseTopDown(TreeNode node) {
		findCaseFromFunction(node);
		
		// recursion
		for (int i = 0; i < node.getChildren().size(); i++) {
			TreeNode child = node.getChildren().get(i);
			setCaseTopDown(child);
		}
	}
	
	private void findCaseFromFunction(TreeNode node) {
		// case annotation for NPs/DPs
		if (node.getPhrasalCategory().matches("NP|DP")) {
			Case c = node.getMorphology().getCase();
			if (c == MorphInfo.Case.NONE) {
				// try to infer the case top-down (not possible for PPs)
				if (node.getFunctionalCategory().matches("SB|PD|EP")) {
					c = MorphInfo.Case.NOM;
				}
				else if (node.getFunctionalCategory().matches("OA|OA2")) {
					c = MorphInfo.Case.ACC;
				}
				else if (node.getFunctionalCategory().matches("OG")) {
					c = MorphInfo.Case.GEN;
				}
				else if (node.getFunctionalCategory().matches("DA")) {
					c = MorphInfo.Case.DAT;
				}
			}
			
			if (c == MorphInfo.Case.NONE) {
				TreeNode head = node;
				while (true) {
					
					while (head.getTop() != null 
							&& head.getTop().isAdjTree()
							&& head.getTop().getRoot().isCoordinatedCat()
							&& head == head.getTop().getFoot()) {
						head = head.getTop().getRoot();
						if (head.getMorphology().getCase() != Case.NONE || head.getParent() == null) break;
					}
					
					if (!head.isHead() || head.getMorphology().getCase() != Case.NONE || head.getParent() == null) break;
					
					head = head.getParent();
				}
				c = head.getMorphology().getCase();
			}
			
			node.getMorphology().setCase(c);
		}
	}


	private void setCaseBottomUp(TreeNode node) {
		
		// recursion
		for (int i = 0; i < node.getChildren().size(); i++) {
			TreeNode child = node.getChildren().get(i);
			setCaseBottomUp(child);
		}
		
		findCaseFromMorph(node);	
	}


	private void findCaseFromMorph(TreeNode node) {
		
		// case annotation for NPs/DPs
		if (node.getPhrasalCategory().matches("NP|DP")) {
			Case c;
			// coordination auxiliary trees
			if (node.getBottom().isAdjTree()
					&& node.getBottom().getRoot().isCoordinatedCat()
					&& node == node.getBottom().getRoot()) {
				c = node.getBottom().getFoot().getMorphology().getCase();
			}
			else {
				TreeNode head = node;
				while (true) {
					if (head.isLeaf() || head.getMorphology().getCase() != Case.NONE) break;
					
					if (head.getBottom().isAdjTree()
							&& head.getBottom().getRoot().isCoordinatedCat()
							&& head == head.getBottom().getRoot()) {
						head = head.getBottom().getFoot();
						if (head.isLeaf() || head.getMorphology().getCase() != Case.NONE) break;
					}
					
					head = head.getHeadChild();
				}
				c = head.getMorphology().getCase();
			}
			
			node.getMorphology().setCase(c);
		}
		
	}


	public void setMorphologyFromTree(ElementaryTreeNode node) {
		
		// lookup morphology in derived tree
		if (node.getPhrasalCategory().matches("NP|DP")) {
			Case cTop = node.getTreeNodeTop().getMorphology().getCase();
			Case cBot = node.getTreeNodeBottom().getMorphology().getCase();
			if (cTop == cBot) {
				node.getMorphology().setCase(cTop);
			}
//			else {
//				System.out.println("case " + node);
//			}
		}
		
		for (ElementaryTreeNode child : node.getChildren()) {
			setMorphologyFromTree(child);
		}
		
	}

}
