package pltag.german;



public class Trace {

	private TreeNode hole = null;
	private TreeNode filler = null;
	
	public Trace(TreeNode node) {
		parseNode(node);
	}

	public void addInfo(TreeNode node) {
		parseNode(node);		
	}

	private void parseNode(TreeNode node) {
		if( node.isLeaf() && ((LeafNode) node).getFullCategory().startsWith("*T")){
			hole = node;
		}
		else {
			filler = node;
		}
	}

	public TreeNode getHole (){
		return hole;
	}
	
	public TreeNode getFiller(){
		return filler;
	}
	
	public String toString() {
		return hole.toString() + " / " + filler.toString();
	}
}
	

